from flask import Flask, render_template, url_for, flash, redirect, request
from forms import RegistrationForm, LoginForm, UploadForm
from pathlib import Path
import uuid
import piskot #nas progtest
import function #nase funkce 
import main_func

app = Flask(__name__)
app.config['SECRET_KEY'] = '5791628bb0b13ce0c676dfde280ba245'
THIS_DEST = str(Path(__file__).parent.absolute())
UPLOAD_DEST = str(Path(__file__).parent.absolute()) + '/upload_buff/'

posts = [
    {
        'author': 'Corey Schafer',
        'title': 'Blog Post 1',
        'content': 'First post content',
        'date_posted': 'April 20, 2018'
    },
    {
        'author': 'Jane Doe',
        'title': 'Blog Post 2',
        'content': 'Second post content',
        'date_posted': 'April 21, 2018'
    }
]


@app.route("/", methods=['GET', 'POST'])
def home():
    form=UploadForm()
    if request.method == 'POST':
    #if form.validate_on_submit():
        FILE = form.UplFILE.data.filename
        FILE_PATH = UPLOAD_DEST + FILE
        form.UplFILE.data.save(FILE_PATH)

        JSON = form.UplJSON.data.filename
        JSON_PATH = UPLOAD_DEST + JSON
        form.UplJSON.data.save(JSON_PATH)
        choose = form.ChooseType.data

        if choose == '1': #jeden soubor samostatny odevzdan
            return render_template('home.html', title='Test', form=form, data_output = main_func.RunProgTest(FILE_PATH, JSON_PATH, THIS_DEST, 'onefile'), zobrazit_jmeno_slozky = False)
        elif choose == '2': #jedna slozka
            return render_template('home.html', title='Test', form=form, data_output = main_func.RunProgTest(FILE_PATH, JSON_PATH, THIS_DEST, 'archive'), zobrazit_jmeno_slozky = False)
        elif choose == '3': #typ slozka cele tridy
            return render_template('home.html', title='Test', form=form, data_output = main_func.RunProgTest(FILE_PATH, JSON_PATH, THIS_DEST, 'class'), zobrazit_jmeno_slozky = True)
        elif choose == '4': #typ slozka cele tridy(mooodle export)
            return render_template('home.html', title='Test', form=form, data_output = main_func.RunProgTest(FILE_PATH, JSON_PATH, THIS_DEST, 'class_moodle'), zobrazit_jmeno_slozky = True)
    return render_template('home.html', title='Home', form=form, text="Zde bude vysledek testovani", test_jmeno="")


@app.route("/register", methods=['GET', 'POST'])
def register():
    form = RegistrationForm()
    if form.validate_on_submit():
        flash(f'Account created for {form.username.data}!', 'success')
        return redirect(url_for('home'))
    return render_template('register.html', title='Register', form=form)


@app.route("/login", methods=['GET', 'POST'])
def login():
    form = LoginForm()
    if form.validate_on_submit():
        if form.email.data == 'admin@blog.com' and form.password.data == 'password':
            flash('You have been logged in!', 'success')
            return redirect(url_for('home'))
        else:
            flash('Login Unsuccessful. Please check username and password', 'danger')
    return render_template('login.html', title='Login', form=form)


if __name__ == '__main__':
    app.run(debug=True)
