import function
import piskot
import multiprocessing as mp
import glob
import os

POCET_PROCESU_PARALEL = 10

def RunProgTest(PATH_TO_ARCHIVE = "", PATH_TO_JSON = "", THIS_DEST = "", file_archive_class = ''):  #methoda vrati dictionary bud cele tridy nebo jednoho zaka(jedne slozk)
    if file_archive_class == 'onefile' or file_archive_class == 'archive':
        FILE_PATH = function.BashCommandReturnOutput([THIS_DEST + '/unpack.sh', file_archive_class, PATH_TO_ARCHIVE]).replace('\n', '') 
        data_output = piskot.RunPiskotTest(PATH_TO_JSON, FILE_PATH)       #datovy tip dictionary 
        final_dict = []
        final_dict.append(data_output)
        return final_dict
    elif file_archive_class == 'class':
        FILE_PATH = function.BashCommandReturnOutput([THIS_DEST + '/unpack.sh', 'archive', PATH_TO_ARCHIVE]).replace('\n', '')
        list_of_dirs = [f.path for f in os.scandir(FILE_PATH) if f.is_dir()]
        pool = mp.Pool(mp.cpu_count())
        result = [pool.apply(piskot.RunPiskotTest, args=(PATH_TO_JSON, student_path)) for student_path in list_of_dirs]
        pool.close()
        return result
    elif file_archive_class == 'class_moodle':
        FILE_PATH = function.BashCommandReturnOutput([THIS_DEST + '/unpack.sh', 'archive', PATH_TO_ARCHIVE, 'moodle']).replace('\n', '')
        list_of_dirs = [f.path for f in os.scandir(FILE_PATH) if f.is_dir()]
        pool = mp.Pool(processes=20)
        result = [pool.apply(piskot.RunPiskotTest, args=(PATH_TO_JSON, student_path)) for student_path in list_of_dirs]
        pool.close()
        function.BashCommandReturnOutput([THIS_DEST + '/unpack.sh', 'remove', FILE_PATH])
        return result
    else:
        return []