#!/bin/bash
#./unpack.sh <archive/onefile/remove> <archived_file> <"moodle">
Job=$1
arch_rem_file=$2 #cesta k zipu nebo ke slozce ktera se smaze
arg1=$3
Final_Dir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )/upload_buff/$(uuidgen)"
#Final_Dir="/root/web/versions/web/upload_buff/$(uuidgen)"

if [ $Job == "archive" ]
then 
  #final_file="${arch_rem_file%.*}"  #jmeno souboru 
  extension="${arch_rem_file##*.}"  #koncovka souboru
  mkdir -p "$Final_Dir"
  if [ $extension == "zip" ] 
  then
    unzip "$arch_rem_file" -d "$Final_Dir" >/dev/null 2>&1
  elif [ $extension == "tar.xz" ] 
  then
    tar -C "$Final_Dir" -xvf "$arch_rem_file" >/dev/null 2>&1
  elif [ $extension == "7z" ] 
  then
    7z e "$arch_rem_file" >/dev/null 2>&1
  elif [ $extension == "rar" ] 
  then
    cd "$Final_Dir"; unrar x "$arch_rem_file" >/dev/null 2>&1; cd ..
  elif [ $extension == "tar.gz" ] 
  then
    tar -xzf "$arch_rem_file" >/dev/null 2>&1
  elif [ $extension == "tar" ] 
  then
    tar -xvf "$arch_rem_file" >/dev/null 2>&1
  fi

  #rm -f $arch_rem_file
  cd "$Final_Dir"
  maybe_subdir=$(ls)
  #pokud nekdo zazizpoval slozku, tak vystupem je slozka ve slozce a to se snazime zjistit jestli tak je
  if [ $(ls | wc -l) -eq 1 ] && [ -d "$maybe_subdir" ] && [ $(ls "$maybe_subdir" | wc -l) -ge 1 ]  
  then
    mv "$maybe_subdir"/* "$Final_Dir"/
    rm -rf "$maybe_subdir"
  fi


  if [[ $arg1 == "moodle" ]]   #pokud se jedna o moodle typ slozky
  then
    rm -rf *online*
    for file in *
    do
      text=$(echo $file | iconv -f UTF8 -t US-ASCII//TRANSLIT)
      text=$(echo $text | sed -e "s/_assignsubmission_file_//")
      #text=$(echo $text | sed -e "s/_/./")
      text=$(echo $text | sed -e "s/ /-/")
      text=$(echo $text | sed 's/_[0-9]*//g')
      mv "$file" "$text"
    done
  fi

  echo "$Final_Dir"
elif [ $Job == "onefile" ]
then
  mkdir -p "$Final_Dir"
  mv "$arch_rem_file" "$Final_Dir"/
  echo "$Final_Dir"
elif [ $Job == "remove" ] && [ -d "$arch_rem_file" ] #smaze slozku
then
  rm -rf "$arch_rem_file"
  rm -rf "$Final_Dir"
fi

